/****************************************************************
*
* Copyright (C) 2004 SignalQuest, Inc.
*
*----------------------------------------------------------------
* All software and related documentation is provided "AS IS" and 
* without warranty or support of any kind and SignalQuest 
* expressly disclaims all other warranties, express or implied, 
* including, but not limited to, the implied warranties of 
* merchantability and fitness for a particular purpose. Under no 
* circumstances shall SignalQuest be liable for any 
* incidental, special or consequential damages that result from 
* the use or inability to use the software or related 
* documentation, even if SignalQuest has been advised of 
* the liability.
*
* Unless otherwise stated, software written and copyrighted by 
* SignalQuest is distributed as "freeware". You may use 
* and modify this software without any charge or restriction. 
* You may distribute to others, as long as the original author 
* is acknowledged.
*
*****************************************************************
* 
* Project:  SignalQuest Serial Communications DLL
*
* File:    RS232Messages.h
*
* History:
*   Version 1.5 (2004-08-30)
*
****************************************************************/


// RS232Messages.h




// Ensure header is only included once per module
#ifndef _SQRS232MESSAGES
#define _SQRS232MESSAGES



// Defines
#define DATA_MODE_LOAD_DLL			-1
#define DATA_MODE_STOP				0
#define DATA_MODE_SYNC				1
#define DATA_MODE_ASYNC_NO_EVENT	2
#define DATA_MODE_ASYNC_EVENT		3
#define DIG_IO_TURN_ON_EVENTS		4
#define DIG_IO_TURN_OFF_EVENTS		5


// Default time (ms) to wait for an RS-232 RX or TX timeout
#define DEFAULT_RS232_TIMEOUT			75

// Various necessary defines
#define PACKET_SIZE						10
#define MAX_MESSAGE_PUMP				100
#define MODE_SYNCHRONOUS				0
#define MODE_ASYNCHRONOUS				1

// Default time (ms) to wait for an event object
#define SYNC_GET_DATA_WAIT				1500

//pmt was:#define FIND_DEVICE_WAIT			3000
//#define OPEN_PORT_WAIT					3000
//#define CLOSE_PORT_WAIT					3000

#define FIND_DEVICE_WAIT				100
//#define OPEN_PORT_WAIT					0000
//#define CLOSE_PORT_WAIT					0000

#define NEAR_INFINITE					3000	//pmt Allow former INFINITE waits to time out

#define RESET_DEVICE_TIMEOUT			3000
#define SEND_MESSAGE_PAUSE				10


// String length for DLL error message
#define ERROR_STRING_LENGTH				80




// RS232 User-defined windows messages

// Ed:  these are from original Nelson book code sample
const int WM_SERIAL_RX_NOTIFY					= WM_USER + 0x1000;
const int WM_PARITY_ERROR_NOTIFY				= WM_USER + 0x1001;
const int WM_BREAK_DETECT_NOTIFY				= WM_USER + 0x1002;
const int WM_FRAMING_ERROR_NOTIFY				= WM_USER + 0x1003;
const int WM_HARDWARE_OVERRUN_ERROR_NOTIFY		= WM_USER + 0x1004;
const int WM_SOFTWARE_OVERRUN_ERROR_NOTIFY		= WM_USER + 0x1005;
const int WM_CTS_NOTIFY							= WM_USER + 0x1006;
const int WM_DSR_NOTIFY							= WM_USER + 0x1007;
const int WM_CD_NOTIFY							= WM_USER + 0x1008;
const int WM_RI_NOTIFY							= WM_USER + 0x1009;
const int WM_TX_NOTIFY							= WM_USER + 0x100a;

// Ed:  these are my additional SQ messages
const int WM_SQ_PACKET_READ						= WM_USER + 0x100b;
const int WM_DUMMY_MESSAGE						= WM_USER + 0x100c;
const int WM_PACKET_NOTIFY						= WM_USER + 0x100d;




// Typedefs

// Two-value packet struct
typedef struct tagSQPacket2
{
	unsigned short		usPacketCount;				// Current packet count
	signed short		ssCurrentErrorState;		// Current packet error state
	unsigned short		usLatchedErrorState;		// Latched error state
	unsigned short		usValue1;					// Current value 1 (pitch)
	unsigned short		usValue2;					// Current value 2 (roll)
} SQPACKET2, *LPSQPACKET2;




#endif
