/****************************************************************
*
* Copyright (C) 2004 SignalQuest, Inc.
*
*----------------------------------------------------------------
* All software and related documentation is provided "AS IS" and 
* without warranty or support of any kind and SignalQuest 
* expressly disclaims all other warranties, express or implied, 
* including, but not limited to, the implied warranties of 
* merchantability and fitness for a particular purpose. Under no 
* circumstances shall SignalQuest be liable for any 
* incidental, special or consequential damages that result from 
* the use or inability to use the software or related 
* documentation, even if SignalQuest has been advised of 
* the liability.
*
* Unless otherwise stated, software written and copyrighted by 
* SignalQuest is distributed as "freeware". You may use 
* and modify this software without any charge or restriction. 
* You may distribute to others, as long as the original author 
* is acknowledged.
*
*****************************************************************
* 
* Project:  SignalQuest Serial Communications DLL Demo Program in VC++
*
* File:    TestSQInclDlg.cpp
*
* History:
*   Version 1.71 (2004-11-11) pmt. Repetitions box added. Uses SQincl.dll
*                                  Window messages dispatched during linear test.
*   Version 1.5 (2004-08-30)
*
****************************************************************/


// TestSQInclDlg.cpp : implementation file
//


#include "stdafx.h"
#include "TestSQIncl.h"
#include "TestSQInclDlg.h"

#include "SQRS232Errors.h"
#include "SQDLLFuncProt.h"




#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestSQInclDlg dialog

CTestSQInclDlg::CTestSQInclDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestSQInclDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTestSQInclDlg)
	m_SaveToDisk = FALSE;
	m_Repetitions = 1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestSQInclDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTestSQInclDlg)
	DDX_Control(pDX, IDC_TOGGLE_RTS_STATUS, m_cbToggleRtsStatus);
	DDX_Control(pDX, IDC_TOGGLE_DTR_STATUS, m_cbToggleDtrStatus);
	DDX_Control(pDX, IDC_EDIT_RTS_STATUS, m_ceRtsStatus);
	DDX_Control(pDX, IDC_EDIT_DTR_STATUS, m_ceDtrStatus);
	DDX_Control(pDX, IDC_EDIT_DSR_STATUS, m_ceDsrStatus);
	DDX_Control(pDX, IDC_EDIT_CTS_STATUS, m_ceCtsStatus);
	DDX_Control(pDX, IDC_OPEN_PORT, m_cbOpenClosePort);
	DDX_Control(pDX, IDC_POINTS_TO_ACQUIRE, m_Points2Acquire);
	DDX_Control(pDX, IDC_LISTBOX_STATUS, m_lbStatus);
	DDX_Control(pDX, IDC_CBOX_SYNC_MODE, m_cbSyncMode);
	DDX_Control(pDX, IDC_DUPLICATE_PACKETS, m_DuplicatePackets);
	DDX_Control(pDX, IDC_LATCHED_ERROR, m_LatchedError);
	DDX_Control(pDX, IDC_DROPPED_PACKETS, m_DroppedPackets);
	DDX_Control(pDX, IDC_PACKET_COUNT, m_PacketCount);
	DDX_Control(pDX, IDC_LOOP_TIMER, m_LoopTimer);
	DDX_Control(pDX, IDC_COM_PORT, m_COMPort);
	DDX_Check(pDX, IDC_SAVE_TO_DISK, m_SaveToDisk);
	DDX_Text(pDX, IDC_REPETITIONS, m_Repetitions);
	DDV_MinMaxUInt(pDX, m_Repetitions, 1, 9999);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTestSQInclDlg, CDialog)
	//{{AFX_MSG_MAP(CTestSQInclDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_OPEN_PORT, OnOpenPort)
	ON_BN_CLICKED(IDC_GET_DATA, OnGetData)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_CLEAR_LATCHED_ERROR, OnClearLatchedError)
	ON_BN_CLICKED(IDC_SEND_RESET, OnSendReset)
	ON_BN_CLICKED(IDC_SET_FILE, OnSetFile)
	ON_BN_CLICKED(IDC_SAVE_TO_DISK, OnSaveToDisk)
	ON_BN_CLICKED(IDC_LINEAR_TEST, OnLinearTest)
	ON_BN_CLICKED(IDC_START_DATA_LOOP, OnStartDataLoop)
	ON_BN_CLICKED(IDC_STOP_DATA_LOOP, OnStopDataLoop)
	ON_BN_CLICKED(IDC_FIND_FIRST_DEVICE, OnFindFirstDevice)
	ON_BN_CLICKED(IDC_TOGGLE_DTR_STATUS, OnToggleDtrStatus)
	ON_BN_CLICKED(IDC_TOGGLE_RTS_STATUS, OnToggleRtsStatus)
	ON_BN_CLICKED(IDC_GET_CTS_STATUS, OnGetCtsStatus)
	ON_BN_CLICKED(IDC_GET_DSR_STATUS, OnGetDsrStatus)
	ON_EN_KILLFOCUS(IDC_REPETITIONS, OnKillfocusRepetitions)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestSQInclDlg message handlers

BOOL CTestSQInclDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon


	// Initialize variables
	InitVars();


	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CTestSQInclDlg::InitVars(void)
{
	// Timer variable default to zero
	m_nTimer = 0;

	// Streaming mode off
	m_iIsStreaming = 0;

	// Default to COM1
	m_COMPort.SetWindowText("1");
	m_COMPort.Invalidate();

	// Loop timer default
	char szLoopTimer[5];
	sprintf(szLoopTimer, "%d", LOOP_TIMER_DEFAULT);
	m_LoopTimer.SetWindowText(szLoopTimer);
	m_LoopTimer.Invalidate();

	// Packet counter
	char szPacketCount[5];
	sprintf(szPacketCount, "%d", 0);
	m_PacketCount.SetWindowText(szPacketCount);
	m_PacketCount.Invalidate();

	// Dropped packets
	char szDroppedPackets[5];
	sprintf(szDroppedPackets, "%d", 0);
	m_DroppedPackets.SetWindowText(szDroppedPackets);
	m_DroppedPackets.Invalidate();

	// Latched error condition
	char szLatchedError[5];
	sprintf(szLatchedError, "%d", 0);
	m_LatchedError.SetWindowText(szLatchedError);
	m_LatchedError.Invalidate();

	// Latched error condition
	char szDuplicatePackets[5];
	sprintf(szDuplicatePackets, "%d", 0);
	m_DuplicatePackets.SetWindowText(szDuplicatePackets);
	m_DuplicatePackets.Invalidate();

	// Data sync mode drop-down list box
	char szDataSync[80];
	sprintf(szDataSync, "Synchronous Mode");
	m_cbSyncMode.InsertString(0, szDataSync);
	sprintf(szDataSync, "Asynchronous Mode");
	m_cbSyncMode.InsertString(1, szDataSync);
	sprintf(szDataSync, "Async Event-Driven Mode");
	m_cbSyncMode.InsertString(2, szDataSync);
	m_cbSyncMode.SetCurSel(0);
	m_cbSyncMode.Invalidate();

	// Points to acquire in linear test
	char szPoints2Acquire[5];
	sprintf(szPoints2Acquire, "%d", 25);
	m_Points2Acquire.SetWindowText(szPoints2Acquire);
	m_Points2Acquire.Invalidate();

	//char szRepetitions[5];
	//sprintf(szRepetions, "%d", 1);
	//m_Repetitions.SetWindowText(szRepetitions);
	//m_Repetitions.Invalidate();

	// Default status text
	char szStatus[80];
	sprintf(szStatus, "SignalQuest Windows Serial Communications API");
	SetStatusText(szStatus);
	m_iStatusLineCount = 1;


	// No port open to start
	m_iPortIsOpen = 0;

	// Default to read
	m_iDoGetData = 1;

	// Default timer get data flag
	m_iDoGetData = 0;

	// Previous packet count
	m_usPrevPacketCount = 0;

	// Dropped packet count
	m_usDroppedPackets = 0;

	// Latched error
	m_usLatchedError = 0;

	// Duplicate packet counter
	m_usDuplicatePackets = 0;

	// File pointer
	m_pFile = 0;

	// File name
	sprintf(m_szFileName, "");

	// Packet read event
	m_hPacketReadEvent = 0;

	// Default synchronization mode to synchronized
	m_iDataSyncMode = MODE_SYNC;


	// Digital I/O lines (output)
	m_iDtrStatus = 1;
	m_iRtsStatus = 1;
	m_iDsrStatus = 1;
	m_iCtsStatus = 1;

	char szDtr[5];
	sprintf(szDtr, "%d", 1);
	m_ceDtrStatus.SetWindowText(szDtr);
	m_ceDtrStatus.Invalidate();

	char szRts[5];
	sprintf(szRts, "%d", 1);
	m_ceRtsStatus.SetWindowText(szRts);
	m_ceRtsStatus.Invalidate();

	char szDsr[5];
	sprintf(szDsr, "%d", 1);
	m_ceDsrStatus.SetWindowText(szDsr);
	m_ceDsrStatus.Invalidate();

	char szCts[5];
	sprintf(szCts, "%d", 1);
	m_ceCtsStatus.SetWindowText(szCts);
	m_ceCtsStatus.Invalidate();

	m_cbToggleDtrStatus.SetCheck(1);
	m_cbToggleRtsStatus.SetCheck(1);

	UpdateData(FALSE);						// Update other member variables

	// "Load" DLL
	// Must call this first to enable other DLL functions
	LONG liVal1, liVal2;
	SQConfig(MODE_LOAD_DLL, 0, RS232TIMEOUT, &liVal1, &liVal2);
}


void CTestSQInclDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.


void CTestSQInclDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// Draw title text
		CFont TitleFont;
		CDC *pDC = this->GetDC();

		TitleFont.CreateFont(
			30,
			10,
			0,
			0,
			400,
			FALSE,
			FALSE,
			0,
			ANSI_CHARSET,
			OUT_DEFAULT_PRECIS,
			CLIP_DEFAULT_PRECIS,
			PROOF_QUALITY,
			DEFAULT_PITCH | FF_ROMAN,
			NULL);

		CFont *pOldFont = pDC->SelectObject(&TitleFont);
		pDC->SetBkMode(TRANSPARENT);
		pDC->TextOut(10, 10, "SignalQuest Windows Serial Communications API VC++");
		pDC->SelectObject(pOldFont);


		CDialog::OnPaint();
	}
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTestSQInclDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


BOOL CTestSQInclDlg::DestroyWindow() 
{
	return CDialog::DestroyWindow();
}


void CTestSQInclDlg::Shutdown(void)
{
	// If timer is still running
	if(m_nTimer != 0)
	{
		KillTimer(m_nTimer);
	}


	//Sleep(1000);


	// If port is still open
	if(m_iPortIsOpen == 1)
	{
		ClosePort(0);
	}


	// If file object still exists
	if(m_pFile != 0)
	{
		delete m_pFile;

		m_pFile = 0;
	}
}


void CTestSQInclDlg::OnCancel() 
{
	Shutdown();


	CDialog::OnCancel();
}


void CTestSQInclDlg::OnOK() 
{
	Shutdown();


	CDialog::OnOK();
}


int CTestSQInclDlg::GetCOMPort(LONG * pliCOMPort)
{
	LONG liResult;
	char szDisplay[3];
	int iComPort;


	// Assume no error
	liResult = 0;


	m_COMPort.GetWindowText(szDisplay, 3);
	iComPort = atoi(szDisplay);

	if((iComPort >= 1) && (iComPort <= 256))
	{
		*pliCOMPort = iComPort;
	}
	else
	{
		liResult = -1;
	}


	return(liResult);
}


void CTestSQInclDlg::OnOpenPort()
{
	int iResult = 0;


	// Opening or closing
	if(m_iPortIsOpen == 0)
	{
		// Attempt to open COM port
		iResult = OpenPort(0);


		// If successfull
		if(iResult == 0)
		{
			m_cbOpenClosePort.SetWindowText("Close Port");
			m_cbOpenClosePort.Invalidate();
		}
	}
	else
	{
		// In case data loop is running
		DoStopDataLoop();


		// Attempt to close COM port
		iResult = ClosePort(0);


		// If successfull
		if(iResult == 0)
		{
			m_iDataSyncMode = MODE_SYNC;

			m_cbOpenClosePort.SetWindowText("Open Port");
			m_cbOpenClosePort.Invalidate();
		}
	}
}


int CTestSQInclDlg::OpenPort(int iOptCom)
{
	LONG liResult;
	LONG liBaudRate;
	LONG liWordSize;
	LONG liStopBits;
	LONG liXonXoff;
	LONG liRtsCts;
	LONG liDtrDsr;
	LONG liCOMPort;
	char szParity[5];
	char szMessage[80];


	liResult = -1;


	// If COM port is within 1-256
	if(GetCOMPort(&liCOMPort) == 0)
	{
		if(iOptCom > 0)
		{
			liCOMPort = iOptCom;
		}

		liBaudRate = 115200;
		liWordSize = 8;
		liStopBits = 1;
		liXonXoff = 0;
		liRtsCts = 0;
		liDtrDsr = 0;
		sprintf(szParity, "NONE");


		sprintf(szMessage, "Attempting to open COM%d", liCOMPort);
		SetStatusText(szMessage);
		//pmt SetStatusText("This may take some time ...");


		// Open COM port
		liResult = SQOpenPort(
			liCOMPort,
			liBaudRate,
			szParity,
			liWordSize,
			liStopBits,
			liXonXoff,
			liRtsCts,
			liDtrDsr);


		// Check liResult for error
		// A return value of 0 means no error
		if(liResult != 0)
		{
			DisplayErrorText(liResult);
		}
		else
		{
			char szMessage[80];
			sprintf(szMessage, "Opened COM%d", liCOMPort);
			SetStatusText(szMessage);
			m_iPortIsOpen = 1;

			// Default to synchronous mode
			LONG liVal1, liVal2;
			SQConfig(MODE_SYNC, 0, RS232TIMEOUT, &liVal1, &liVal2);

			// Disable COM input
			m_COMPort.EnableWindow(FALSE);
			m_COMPort.Invalidate();
		}
	}
	else
	{
		AfxMessageBox("Value must be 1 to 256");
		SetStatusText("COM Port Not Within Range");
	}


	return(liResult);
}


int CTestSQInclDlg::ClosePort(int iOptCom)
{
	LONG liCOMPort;
	LONG liResult = -1;
	char szMessage[80];


	// If COM port is within 1-256
	if(GetCOMPort(&liCOMPort) == 0)
	{
		if(iOptCom > 0)
		{
			liCOMPort = iOptCom;
		}


		sprintf(szMessage, "Closing COM%d", liCOMPort);
		SetStatusText(szMessage);
		//pmt SetStatusText("This may take some time ...");

		
		// Close COM Port
		liResult = SQClosePort(liCOMPort);


		// Check liResult for error
		// A return value of 0 means no error
		if(liResult != 0)
		{
			DisplayErrorText(liResult);
		}
		else
		{
			char szMessage[80];
			sprintf(szMessage, "Closed COM%d", liCOMPort);
			SetStatusText(szMessage);
			m_iPortIsOpen = 0;

			// If timer is still running
			if(m_nTimer != 0)
			{
				KillTimer(m_nTimer);
			}

			// Enable COM input
			m_COMPort.EnableWindow(TRUE);
			m_COMPort.Invalidate();
		}
	}
	else
	{
		AfxMessageBox("Value must be 1 to 256");
		SetStatusText("COM Port Not Within Range");
	}


	return(liResult);
}


void CTestSQInclDlg::OnGetData() 
{
	LONG liVal1, liVal2;


	// Get one packet of data
	SQConfig(MODE_STOP, 0, RS232TIMEOUT, &liVal1, &liVal2);
	SQConfig(MODE_SYNC, 0, RS232TIMEOUT, &liVal1, &liVal2);


	GetData(0);
}


int CTestSQInclDlg::GetData(int iOptCom)
{
	LONG liResult;
	LONG liCOMPort;
	FLOAT fPitch;
	FLOAT fRoll;
	LONG liPacketCount;
	LONG liCurrentError;
	LONG liLatchedError;
	LONG liBytesAvail;
	char szDisplay[80];
	int iLoopTimer;
	int iPacketDiff;
	char szLoopTimer[10];
	int iUpdatePackets;
	WRITEPACKET CurrentPacket;


	// Assume no error
	liResult = 0;


	// Default to update packet count info
	// (unless there is a timeout error)
	iUpdatePackets = 1;


	// If COM port is within 1-256
	if(GetCOMPort(&liCOMPort) == 0)
	{
		if(iOptCom > 0)
		{
			liCOMPort = iOptCom;
		}


		// Initialize pitch and roll
		fPitch = 0.0;
		fRoll = 0.0;


		m_LoopTimer.GetWindowText(szLoopTimer, 3);
		iLoopTimer = atoi(szLoopTimer);

		if((iLoopTimer >= 1) && (iLoopTimer <= 10000))
		{
			if(m_iDataSyncMode == MODE_ASYNC_EVENT)
			{
				// Wait for event
				::WaitForSingleObject(m_hPacketReadEvent, ASYNC_EVENT_WAIT);
			}


			// Get one packet of data from a SignalQuest Inclinometer sensor
			liResult = SQGetData2(
				liCOMPort,
				&fPitch,
				&fRoll,
				&liPacketCount,
				&liCurrentError,
				&liLatchedError,
				&liBytesAvail);


			// Check liResult for error
			if(liResult != 0)
			{
				DisplayErrorText(liResult);

				if(liResult != ERROR_READ_PACKET_CHECKSUM)
				{
					iUpdatePackets = 0;
				}
			}

			// If a timeout error occured no need to update packets
			// as no new values will be read.
			if(iUpdatePackets == 1)
			{
				// Update status window
				sprintf(szDisplay, "Pitch:  %10.2f    Roll:  %10.2f,    Error: %d",
											fPitch, fRoll, liCurrentError);
				SetStatusText(szDisplay);

				// Check packet count
				iPacketDiff = liPacketCount - m_usPrevPacketCount;

				// We expect packet diff to be = 1 for normal reading
				if(iPacketDiff == 1)
				{
					// Normal case, zero out duplicate counter
					m_usDuplicatePackets = 0;
				}

				// If packets were skipped
				if(iPacketDiff > 1)
				{
					if( !(
						((m_iDataSyncMode == MODE_ASYNC_NO_EVENT) ||
						(m_iDataSyncMode == MODE_ASYNC_EVENT)) &&
						(m_usPrevPacketCount == 0)) )
					{
						// Incrememt dropped packet counter
						m_usDroppedPackets += (iPacketDiff - 1);
					}
				}

				// If packet diff is negative
				if(iPacketDiff < 0)
				{
					// Unsigned short rollover case
					iPacketDiff = iPacketDiff + 65536;
				}

				// If same packet read twice in a row or more
				if(iPacketDiff == 0)
				{
					// Buffer has not been updated yet
					m_usDuplicatePackets++;

					// If several duplicate packets are read in a row
					if(m_usDuplicatePackets >= 3)
					{
						// Update status window
						SetStatusText("Duplicate Packets Read (3 or more)");
						liResult = -5;
					}
				}

				// Update stored packet counter
				m_usPrevPacketCount = (unsigned int)liPacketCount;



				// Check for latched error
				if(liLatchedError != 0)
				{
					m_usLatchedError = 1;
				}


				// Update packet counter
				char szPacketCount[5];
				sprintf(szPacketCount, "%d", liPacketCount);
				m_PacketCount.SetWindowText(szPacketCount);
				m_PacketCount.Invalidate();

				// Dropped packets
				char szDroppedPackets[5];
				sprintf(szDroppedPackets, "%d", m_usDroppedPackets);
				m_DroppedPackets.SetWindowText(szDroppedPackets);
				m_DroppedPackets.Invalidate();

				// Latched error condition
				char szLatchedError[5];
				sprintf(szLatchedError, "%d", m_usLatchedError);
				m_LatchedError.SetWindowText(szLatchedError);
				m_LatchedError.Invalidate();

				// Duplicate packets
				char szDuplicatePackets[5];
				sprintf(szDuplicatePackets, "%d", m_usDuplicatePackets);
				m_DuplicatePackets.SetWindowText(szDuplicatePackets);
				m_DuplicatePackets.Invalidate();
			}
		}
		else
		{
			AfxMessageBox("Value must be 1 to 10000");
			SetStatusText("Loop Timer Not Within Range");
			liResult = -6;
		}
	}
	else
	{
		AfxMessageBox("Value must be 1 to 256");
		SetStatusText("COM Port Not Within Range");
		liResult = -7;
	}

	// Write to disk if saving
	if((m_pFile != 0) && (m_SaveToDisk == 1) && (liResult == ERROR_NO_ERROR))
	{
		CurrentPacket.fPitch = fPitch;
		CurrentPacket.fRoll = fRoll;
		CurrentPacket.liPacketCount = liPacketCount;
		CurrentPacket.liErrorCode = liCurrentError;

		WriteToDiskFile(&CurrentPacket);
	}


	// For port-polling
	if(liPacketCount == 0)
	{
		liResult = -8;
	}


	return(liResult);
}


void CTestSQInclDlg::OnStartDataLoop() 
{
	if(m_iPortIsOpen == 0)
	{
		SetStatusText("COM Port Not Open");
	}
	else
	{
		DoStartDataLoop();
	}
}


void CTestSQInclDlg::OnStopDataLoop() 
{
	if(m_iPortIsOpen == 0)
	{
		SetStatusText("COM Port Not Open");
	}
	else
	{
		DoStopDataLoop();
	}
}


void CTestSQInclDlg::DoStartDataLoop(void) 
{
	// Disable sync mode dropdown listbox
	m_cbSyncMode.EnableWindow(FALSE);
	m_cbSyncMode.Invalidate();

	// Disable loop timer input
	m_LoopTimer.EnableWindow(FALSE);
	m_LoopTimer.Invalidate();


	DataModeSwitch();


	int iLoopTimer;
	char szLoopTimer[10];


	m_LoopTimer.GetWindowText(szLoopTimer, 10);
	iLoopTimer = atoi(szLoopTimer);

	if((iLoopTimer >= 1) && (iLoopTimer <= 10000))
	{
		// Streaming flag on
		m_iIsStreaming = 1;

		// Create timer object
		m_nTimer = SetTimer(TIMER_ID, iLoopTimer, 0);
		m_iDoGetData = 1;

		// If saving to disk
		if(m_SaveToDisk == 1)
		{
			// Open file for write
			OpenDiskFile();
		}
	}
	else
	{
		AfxMessageBox("Value must be 1 to 10000");
		SetStatusText("Loop Timer Not Within Range");
	}
}


void CTestSQInclDlg::OpenDiskFile(void)
{
	if(strlen(m_szFileName) > 0)
	{
		m_pFile = new CFile();

		m_pFile->Open(m_szFileName, CFile::modeCreate | CFile::modeWrite);
	}
	else
	{
		// Filename error
	}
}


void CTestSQInclDlg::CloseDiskFile(void)
{
	if(m_pFile != 0)
	{
		m_pFile->Close();

		delete m_pFile;

		m_pFile = 0;
	}
}


void CTestSQInclDlg::WriteToDiskFile(PWRITEPACKET pCurrentPacket)
{
	char szBuffer[80];

	sprintf(szBuffer, "%7.1f, %7.1f, %6d, %6d\r\n",
		pCurrentPacket->fPitch,
		pCurrentPacket->fRoll,
		pCurrentPacket->liPacketCount,
		pCurrentPacket->liErrorCode);

	m_pFile->Write(szBuffer, lstrlen(szBuffer));
}


void CTestSQInclDlg::DoStopDataLoop() 
{
	StopLoopData();


	if(m_SaveToDisk == 1)
	{
		CloseDiskFile();
	}


	// Enable sync mode dropdown listbox
	m_cbSyncMode.EnableWindow(TRUE);
	m_cbSyncMode.Invalidate();

	// Enable loop timer input
	m_LoopTimer.EnableWindow(TRUE);
	m_LoopTimer.Invalidate();
}


void CTestSQInclDlg::StopLoopData(void)
{
	LONG liVal1, liVal2;


	SQConfig(MODE_STOP, 0, RS232TIMEOUT, &liVal1, &liVal2);


	if(m_iIsStreaming == 1)
	{
		m_iDoGetData = 0;

		KillTimer(m_nTimer);

		m_nTimer = 0;

		m_iIsStreaming = 0;
	}
}


void CTestSQInclDlg::OnTimer(UINT nIDEvent) 
{
	int iError;
	char c;


	iError = 0;

	// Get packet of data at timed intervals
	if(m_iDoGetData == 1)
	{
		m_iDoGetData = 0;


		iError = GetData(0);


		if(iError != 0)
		{
			c = 'c';
		}


		m_iDoGetData = 1;
	}


	CDialog::OnTimer(nIDEvent);
}


void CTestSQInclDlg::OnClearLatchedError() 
{
	LONG liCOMPort;


	// If COM port is within 1-256
	if(GetCOMPort(&liCOMPort) == 0)
	{
		m_usLatchedError = 0;


		SetStatusText("Clearing Latched Error");

		
		SQClearLatchedError(liCOMPort);


		// Latched error condition
		char szLatchedError[5];
		sprintf(szLatchedError, "%d", m_usLatchedError);
		m_LatchedError.SetWindowText(szLatchedError);
		m_LatchedError.Invalidate();
	}
	else
	{
		AfxMessageBox("Value must be 1 to 256");
		SetStatusText("COM Port Not Within Range");
	}
}


void CTestSQInclDlg::OnSendReset() 
{
	LONG liCOMPort;


	// If COM port is within 1-256
	if(GetCOMPort(&liCOMPort) == 0)
	{
		SetStatusText("Resetting Device");


		// Reset SQ Inclinometer
		int iResult = SQResetDevice(liCOMPort);


		if(iResult == 0)
		{
			SetStatusText("Reset Successfull");


			// Update packet counter
			m_usPrevPacketCount = 0;
			char szPacketCount[5];
			sprintf(szPacketCount, "%d", m_usPrevPacketCount);
			m_PacketCount.SetWindowText(szPacketCount);
			m_PacketCount.Invalidate();

			// Dropped packets
			m_usDroppedPackets = 0;
			char szDroppedPackets[5];
			sprintf(szDroppedPackets, "%d", m_usDroppedPackets);
			m_DroppedPackets.SetWindowText(szDroppedPackets);
			m_DroppedPackets.Invalidate();

			// Duplicate packets
			m_usDuplicatePackets = 0;
			char szDuplicatePackets[5];
			sprintf(szDuplicatePackets, "%d", m_usDuplicatePackets);
			m_DuplicatePackets.SetWindowText(szDuplicatePackets);
			m_DuplicatePackets.Invalidate();
		}
		else
		{
			DisplayErrorText(iResult);
		}
	}
	else
	{
		AfxMessageBox("Value must be 1 to 256");

		SetStatusText("COM Port Not Within Range");
	}
}


void CTestSQInclDlg::OnSetFile() 
{
	// Popup file chooser dialog
	CFileDialog * pFileChooser = new CFileDialog(
		FALSE,
		"txt",
		NULL,
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		NULL,
		this);

	pFileChooser->DoModal();

	sprintf(m_szFileName, "%s", pFileChooser->GetFileName());

	delete pFileChooser;
}


void CTestSQInclDlg::OnSaveToDisk() 
{
	UpdateData(TRUE);
}


//*********************************************************
int CTestSQInclDlg::FindFirstDevice(int iComLo, int iComHi)
{
	LONG liResult;
	LONG liBaudRate;
	LONG liWordSize;
	LONG liStopBits;
	LONG liXonXoff;
	LONG liRtsCts;
	LONG liDtrDsr;
	char szParity[5];


	liBaudRate = 115200;
	liWordSize = 8;
	liStopBits = 1;
	liXonXoff = 0;
	liRtsCts = 0;
	liDtrDsr = 0;
	sprintf(szParity, "NONE");


	// Poll for devices
	liResult = SQFindFirstDevice(
		iComLo,
		iComHi,
		liBaudRate,
		szParity,
		liWordSize,
		liStopBits,
		liXonXoff,
		liRtsCts,
		liDtrDsr);


	return(liResult);
} // End FindFirstDevice


//******************************************
void CTestSQInclDlg::OnFindFirstDevice(void) 
{
	char szMessage[80];

	SetStatusText("Starting Find First Device");
	SetStatusText("This may take some time ...");


	LONG liResult = FindFirstDevice(1, 200);


	SetStatusText("Ending Find First Device");


	if(liResult > 0)
	{
		sprintf(szMessage, "Device Found at COM%d", liResult);
		SetStatusText(szMessage);

		char szCOMPort[5];
		sprintf(szCOMPort, "%d", liResult);
		m_COMPort.SetWindowText(szCOMPort);
		m_COMPort.Invalidate();
	}
	else if(liResult == 0)
	{
		sprintf(szMessage, "Device Not Found");
		SetStatusText(szMessage);
	}
	else
	{
		DisplayErrorText(liResult);
	}
} // End OnFindFirstDevice


//******************************************
void CTestSQInclDlg::DoOpenCloseTest(void)
{
	int p, d, iResult;
	int iComPort = 12;


	for(p=0; p<10; p++)
	{
		iResult = OpenPort(iComPort);

		if(iResult != 0)
		{
			AfxMessageBox("Open Port Failed");
		}


		for(d=0; d<20; d++)
		{
			iResult = GetData(iComPort);
		}


		iResult = ClosePort(iComPort);
	}
}

//******************************************
void CTestSQInclDlg::DoLinearTest(void)
{
	int iResult;
	int iComPort;
	char szPoints[10];
	int iPoints;
	LONG liResult = 0;
	LONG liVal1, liVal2;
	char szMessage[80];
	LONG liDsrEvent, liCtsEvent;


	SetStatusText("Starting Linear Code Test");
	SetStatusText("This may take some time (and cannot be interrupted) ...");

	UpdateData(TRUE);						// Read  member variables


	SQConfig(MODE_STOP, 0, RS232TIMEOUT, &liVal1, &liVal2);

	for (int Loop=0; Loop < (int)m_Repetitions; Loop++) // pmt 
	{

		sprintf(szMessage, "*** Repetition %d. Starting Find First Device", Loop);
		SetStatusText(szMessage);
		//SetStatusText("Starting Find First Device");
		liResult = FindFirstDevice(1, 20);
		SetStatusText("Ending Find First Device");


		// For testing (COM12)
		//liResult = 12;


		if(liResult > 0)
		{
			int i;


			sprintf(szMessage, "Device Found at COM%d", liResult);
			SetStatusText(szMessage);


			iComPort = liResult;


			iResult = OpenPort(iComPort);

			if(iResult == 0)
			{
				m_Points2Acquire.GetWindowText(szPoints, 3);
				iPoints = atoi(szPoints);
				m_Points2Acquire.EnableWindow(FALSE);
				m_Points2Acquire.Invalidate();

				// If saving to disk
				if(m_SaveToDisk == 1)
				{
					// Open file for write
					OpenDiskFile();
				}


				iResult = -1;


				SQConfig(MODE_SYNC, 0, RS232TIMEOUT, &liVal1, &liVal2);

				for(i=0; i<iPoints; i++)
				{
					iResult = GetData(iComPort);


					Sleep(0);
				}


				// Reset SQ Inclinometer
				SetStatusText("Resetting Device");
				iResult = SQResetDevice(iComPort);


				SQConfig(4, 0, 75, &liDsrEvent, &liCtsEvent);

				for(i=0; i<3; i++)
				{
					DoWriteDtr(0);
					DoReadDsr();

					DoWriteDtr(1);
					DoReadDsr();


					DoWriteRts(0);
					DoReadCts();
					
					DoWriteRts(1);
					DoReadCts();
				}

				SQConfig(5, 0, 75, &liDsrEvent, &liCtsEvent);

				
				if(m_SaveToDisk == 1)
				{
					CloseDiskFile();
				}


				iResult = ClosePort(iComPort);


				if(iResult != 0)
				{
					SetStatusText("COM Port Close Error");
					break;
				}


				m_Points2Acquire.EnableWindow(TRUE);
				m_Points2Acquire.Invalidate();
			} // End of successful Open Port
			else
			{
				SetStatusText("Open Port Error");
				break;
			}
		}
		else if(liResult == 0)
		{
			sprintf(szMessage, "Device Not Found");
			SetStatusText(szMessage);
			break;
		}
		else
		{
			DisplayErrorText(liResult);
		}
		
	} // end for i... debug

	SetStatusText("Ending Linear Code Test");
}


void CTestSQInclDlg::OnLinearTest() 
{
	if(m_iPortIsOpen == 0)
	{
		LONG liVal1, liVal2;


		SQConfig(-1, 0, RS232TIMEOUT, &liVal1, &liVal2);


		DoLinearTest();
		//DoOpenCloseTest();
	}
	else
	{
		SetStatusText("Must first close COM port");
	}
}


void CTestSQInclDlg::DataModeSwitch(void)
{
	LONG liVal1, liVal2;


	StopLoopData();


	SQConfig(MODE_STOP, 0, RS232TIMEOUT, &liVal1, &liVal2);

	
	int iCurSel = m_cbSyncMode.GetCurSel();


	switch(iCurSel)
	{
	case 0:
		m_iDataSyncMode = MODE_SYNC;
		SQConfig(MODE_SYNC, 0, RS232TIMEOUT, &liVal1, &liVal2);
		break;

	case 1:
		m_iDataSyncMode = MODE_ASYNC_NO_EVENT;
		SQConfig(MODE_ASYNC_NO_EVENT, 0, RS232TIMEOUT, &liVal1, &liVal2);
		break;

	case 2:
		m_iDataSyncMode = MODE_ASYNC_EVENT;
		SQConfig(MODE_ASYNC_EVENT, 0, RS232TIMEOUT, &liVal1, &liVal2);
		m_hPacketReadEvent = (HANDLE)liVal1;
		break;

	default:
		ASSERT(FALSE);
	}
}


//*****************************************************
void CTestSQInclDlg::SetStatusText(LPCSTR lpszString)
{
	if(m_iStatusLineCount > STATUS_TEXT_LINES)
	{
		m_lbStatus.DeleteString(0);
	}
	else
	{
		m_iStatusLineCount++;
	}

	TRACE("TestSQl: %s\n", lpszString);	//pmt to see it mixed with dbg output

	m_lbStatus.AddString(lpszString);
	m_lbStatus.Invalidate();
	UpdateWindow();
	DispatchMessages();		// Act on any msgs to main window
}


//******************************************************
void CTestSQInclDlg::DisplayErrorText(LONG liErrorCode)
{
	char szBuffer1[80];
	char szBuffer2[256];
	LONG liResult = 0;


	liResult = SQGetErrorString(liErrorCode, 80, szBuffer1);


	if(liResult == 0)
	{
		sprintf(szBuffer2, "Error: %d  %s", liErrorCode, szBuffer1);
	}
	else
	{
		sprintf(szBuffer2, "Error:  %d", liErrorCode);
	}


	SetStatusText(szBuffer2);
}


void CTestSQInclDlg::OnToggleDtrStatus()
{
	m_cbToggleDtrStatus.UpdateData(TRUE);
	m_iDtrStatus = m_cbToggleDtrStatus.GetCheck();


	if(m_iPortIsOpen == 0)
	{
		SetStatusText("COM Port Not Open");
	}
	else
	{
		LONG liResult = 0;
		LONG liDsrEvent, liCtsEvent;


		SQConfig(4, 0, 75, &liDsrEvent, &liCtsEvent);


		if(m_iDtrStatus == 1)
		{
			liResult = DoWriteDtr(1);
		}
		else
		{
			liResult = DoWriteDtr(0);
		}


		if(liResult == 0)
		{
			char szDtr[5];
			sprintf(szDtr, "%d", m_iDtrStatus);
			m_ceDtrStatus.SetWindowText(szDtr);
			m_ceDtrStatus.Invalidate();


			// To wait synchronously for a return CTS event when testing
			// cross lines over on cable and uncomment this line
			//::WaitForSingleObject((HANDLE)liCtsEvent, DATA_IO_TIMEOUT);


			//DoReadDsr();
		}


		SQConfig(5, 0, 75, &liDsrEvent, &liCtsEvent);
	}
}


void CTestSQInclDlg::OnToggleRtsStatus() 
{
	m_cbToggleRtsStatus.UpdateData(TRUE);
	m_iRtsStatus = m_cbToggleRtsStatus.GetCheck();


	if(m_iPortIsOpen == 0)
	{
		SetStatusText("COM Port Not Open");
	}
	else
	{
		LONG liResult = 0;
		LONG liDsrEvent, liCtsEvent;


		SQConfig(4, 0, 75, &liDsrEvent, &liCtsEvent);

		
		if(m_iRtsStatus == 1)
		{
			liResult = DoWriteRts(1);
		}
		else
		{
			liResult = DoWriteRts(0);
		}


		if(liResult == 0)
		{
			char szRts[5];
			sprintf(szRts, "%d", m_iRtsStatus);
			m_ceRtsStatus.SetWindowText(szRts);
			m_ceRtsStatus.Invalidate();


			// To wait synchronously for a return DSR event when testing
			// cross lines over on cable and uncomment this line
			//::WaitForSingleObject((HANDLE)liDsrEvent, DATA_IO_TIMEOUT);


			//DoReadCts();
		}


		SQConfig(5, 0, 75, &liDsrEvent, &liCtsEvent);
	}
}


LONG CTestSQInclDlg::DoWriteDtr(LONG liDtrStatus)
{
	LONG liResult = 0;
	LONG liCOMPort = 0;


	GetCOMPort(&liCOMPort);


	liResult = SQWriteDTR(liCOMPort, liDtrStatus);


	char szMessage[80];
	sprintf(szMessage, "Write %d to DTR", liDtrStatus);
	SetStatusText(szMessage);


	return(liResult);
}


LONG CTestSQInclDlg::DoWriteRts(LONG liRtsStatus)
{
	LONG liResult = 0;
	LONG liCOMPort = 0;


	GetCOMPort(&liCOMPort);


	liResult = SQWriteRTS(liCOMPort, liRtsStatus);


	char szMessage[80];
	sprintf(szMessage, "Write %d to RTS", liRtsStatus);
	SetStatusText(szMessage);


	return(liResult);
}


void CTestSQInclDlg::DoReadCts(void)
{
	if(m_iPortIsOpen == 0)
	{
		SetStatusText("COM Port Not Open");
	}
	else
	{
		LONG liCOMPort = 0;
		LONG liCtsStatus;
		LONG liResult = 0;


		GetCOMPort(&liCOMPort);


		liResult = SQReadCTS(liCOMPort, &liCtsStatus);


		if(liResult == 0)
		{
			m_iCtsStatus = liCtsStatus;


			char szCts[5];
			sprintf(szCts, "%d", liCtsStatus);
			m_ceCtsStatus.SetWindowText(szCts);
			m_ceCtsStatus.Invalidate();


			char szMessage[80];
			sprintf(szMessage, "Read %d from CTS", liCtsStatus);
			SetStatusText(szMessage);
		}
	}
}


void CTestSQInclDlg::DoReadDsr(void)
{
	if(m_iPortIsOpen == 0)
	{
		SetStatusText("COM Port Not Open");
	}
	else
	{
		LONG liCOMPort = 0;
		LONG liDsrStatus;
		LONG liResult = 0;


		GetCOMPort(&liCOMPort);


		liResult = SQReadDSR(liCOMPort, &liDsrStatus);


		if(liResult == 0)
		{
			m_iDsrStatus = liDsrStatus;


			char szDsr[5];
			sprintf(szDsr, "%d", liDsrStatus);
			m_ceDsrStatus.SetWindowText(szDsr);
			m_ceDsrStatus.Invalidate();


			char szMessage[80];
			sprintf(szMessage, "Read %d from DSR", liDsrStatus);
			SetStatusText(szMessage);
		}
	}
}


void CTestSQInclDlg::OnGetCtsStatus() 
{
	DoReadCts();
}


void CTestSQInclDlg::OnGetDsrStatus() 
{
	DoReadDsr();
}

void CTestSQInclDlg::OnKillfocusRepetitions() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	
}

//*************************************
void CTestSQInclDlg::DispatchMessages()
{
MSG msg;

	// Act on any messages in Q 
	// (Call during long operations)

	while (::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
	{
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}
}
